import Head from 'next/head'
import Link from 'next/link'

export const HtmlHead = () => (
  <Head>
    <title>OnLoki</title>
    <meta name="description" content="Get a free subdomain for Lokinet SNApps." />
    <link rel="icon" href="/favicon.ico" />
  </Head>
)

export const PageHead = () => (
  <div>
    <h1 className="title">
      On.Loki
    </h1>

    <p className="description">
      Get a short <b>free</b> subdomain to access your Lokinet SNApp.<br />
      <Link href="/">Home</Link> - <Link href="/faq">FAQ</Link> - <Link href="/tos">TOS</Link> - <a target="_blank" href="http://gitea.on.loki/massivebox/onloki" rel="noopener noreferrer">Code</a>
    </p>
  </div>
)